#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "matrix.h"

/** 
	An algorithm for fuzzy segmentation
	Fraga 1996
**/
void umbral( float **imgin, uchar **imgout, int dim, INFODATA *vals )
{ 
	int i, j;
	float m, m1, m2, tmp;
	int outval;

	m = ( vals->mobj*vals->snoi + vals->mnoi*vals->sobj )/
	    ( vals->sobj + vals->snoi );

	m1 = (vals->mnoi + m )/2;
	m2 = (vals->mobj + m )/2;

	printf( "O=%f, M=%f, N=%f\n", vals->mobj, m, vals->mnoi );
	for ( i=0; i<dim; i++ ) {
		for ( j=0; j<dim; j++ ) {
			tmp = imgin[i][j]; 
			if( vals->mobj > vals->mnoi ) {	
				if ( tmp < vals->mnoi ) outval = 5; 
				else if ( tmp < m1 ) outval = 4; 
				else if ( tmp < m ) outval = 3; 
				else if ( tmp < m2 ) outval = 2; 
				else if ( tmp < vals->mobj ) outval = 1; 
				else outval = 0;
			}
			else {
				if ( tmp < vals->mobj ) outval = 5; 
				else if ( tmp < m2 ) outval = 4; 
				else if ( tmp < m ) outval = 3; 
				else if ( tmp < m1 ) outval = 2; 
				else if ( tmp < vals->mnoi ) outval = 1; 
				else outval = 0;
			}
			imgout[i][j] = (uchar)outval;
		}
	}
}

